"use strict";var et=Object.defineProperty;var s=(e,t)=>et(e,"name",{value:t,configurable:!0});const o=require("util"),c=require("lodash"),y=require("wkx"),n=require("./errors"),f=require("./utils/validator-extras").validator,_=require("moment-timezone"),S=require("moment"),{logger:st}=require("./utils/logger"),D={},{classToInvokable:it}=require("./utils/class-to-invokable"),{joinSQLFragments:T}=require("./utils/join-sql-fragments");class i{toString(t){return this.toSql(t)}toSql(){return this.key}stringify(t,r){return this._stringify?this._stringify(t,r):t}bindParam(t,r){return this._bindParam?this._bindParam(t,r):r.bindParam(this.stringify(t,r))}static toString(){return this.name}static warn(t,r){D[r]||(D[r]=!0,st.warn(`${r} 
>> Check: ${t}`))}static extend(t){return new this(t.options)}}s(i,"ABSTRACT"),i.prototype.dialectTypes="";class b extends i{constructor(t,r){super();const a=typeof t=="object"&&t||{length:t,binary:r};this.options=a,this._binary=a.binary,this._length=a.length||255}toSql(){return T([`VARCHAR(${this._length})`,this._binary&&"BINARY"])}validate(t){if(Object.prototype.toString.call(t)!=="[object String]"){if(this.options.binary&&Buffer.isBuffer(t)||typeof t=="number")return!0;throw new n.ValidationError(o.format("%j is not a valid string",t))}return!0}get BINARY(){return this._binary=!0,this.options.binary=!0,this}static get BINARY(){return new this().BINARY}}s(b,"STRING");class A extends b{constructor(t,r){super(typeof t=="object"&&t||{length:t,binary:r})}toSql(){return T([`CHAR(${this._length})`,this._binary&&"BINARY"])}}s(A,"CHAR");class B extends i{constructor(t){super();const r=typeof t=="object"&&t||{length:t};this.options=r,this._length=r.length||""}toSql(){switch(this._length.toLowerCase()){case"tiny":return"TINYTEXT";case"medium":return"MEDIUMTEXT";case"long":return"LONGTEXT";default:return this.key}}validate(t){if(typeof t!="string")throw new n.ValidationError(o.format("%j is not a valid string",t));return!0}}s(B,"TEXT");class k extends i{toSql(){return"CITEXT"}validate(t){if(typeof t!="string")throw new n.ValidationError(o.format("%j is not a valid string",t));return!0}}s(k,"CITEXT");class u extends i{constructor(t={}){super();typeof t=="number"&&(t={length:t}),this.options=t,this._length=t.length,this._zerofill=t.zerofill,this._decimals=t.decimals,this._precision=t.precision,this._scale=t.scale,this._unsigned=t.unsigned}toSql(){let t=this.key;return this._length&&(t+=`(${this._length}`,typeof this._decimals=="number"&&(t+=`,${this._decimals}`),t+=")"),this._unsigned&&(t+=" UNSIGNED"),this._zerofill&&(t+=" ZEROFILL"),t}validate(t){if(!f.isFloat(String(t)))throw new n.ValidationError(o.format(`%j is not a valid ${this.key.toLowerCase()}`,t));return!0}_stringify(t){return typeof t=="number"||typeof t=="boolean"||t===null||t===void 0?t:typeof t.toString=="function"?t.toString():t}get UNSIGNED(){return this._unsigned=!0,this.options.unsigned=!0,this}get ZEROFILL(){return this._zerofill=!0,this.options.zerofill=!0,this}static get UNSIGNED(){return new this().UNSIGNED}static get ZEROFILL(){return new this().ZEROFILL}}s(u,"NUMBER");class l extends u{validate(t){if(!f.isInt(String(t)))throw new n.ValidationError(o.format(`%j is not a valid ${this.key.toLowerCase()}`,t));return!0}}s(l,"INTEGER");class L extends l{}s(L,"TINYINT");class z extends l{}s(z,"SMALLINT");class P extends l{}s(P,"MEDIUMINT");class Y extends l{}s(Y,"BIGINT");class x extends u{constructor(t,r){super(typeof t=="object"&&t||{length:t,decimals:r})}validate(t){if(!f.isFloat(String(t)))throw new n.ValidationError(o.format("%j is not a valid float",t));return!0}}s(x,"FLOAT");class E extends u{constructor(t,r){super(typeof t=="object"&&t||{length:t,decimals:r})}}s(E,"REAL");class p extends u{constructor(t,r){super(typeof t=="object"&&t||{length:t,decimals:r})}}s(p,"DOUBLE");class j extends u{constructor(t,r){super(typeof t=="object"&&t||{precision:t,scale:r})}toSql(){return this._precision||this._scale?`DECIMAL(${[this._precision,this._scale].filter(c.identity).join(",")})`:"DECIMAL"}validate(t){if(!f.isDecimal(String(t)))throw new n.ValidationError(o.format("%j is not a valid decimal",t));return!0}}s(j,"DECIMAL");const nt={escape:!1,_value(e){return isNaN(e)?"NaN":isFinite(e)?e:`${e<0?"-":""}Infinity`},_stringify(e){return`'${this._value(e)}'`},_bindParam(e,t){return t.bindParam(this._value(e))}};for(const e of[x,p,E])Object.assign(e.prototype,nt);class m extends i{toSql(){return"TINYINT(1)"}validate(t){if(!f.isBoolean(String(t)))throw new n.ValidationError(o.format("%j is not a valid boolean",t));return!0}_sanitize(t){if(t!=null){Buffer.isBuffer(t)&&t.length===1&&(t=t[0]);const r=typeof t;if(r==="string")return t==="true"?!0:t==="false"?!1:t;if(r==="number")return t===1?!0:t===0?!1:t}return t}}s(m,"BOOLEAN"),m.parse=m.prototype._sanitize;class G extends i{toSql(){return"TIME"}}s(G,"TIME");class M extends i{constructor(t){super();const r=typeof t=="object"&&t||{length:t};this.options=r,this._length=r.length||""}toSql(){return"DATETIME"}validate(t){if(!f.isDate(String(t)))throw new n.ValidationError(o.format("%j is not a valid date",t));return!0}_sanitize(t,r){return(!r||r&&!r.raw)&&!(t instanceof Date)&&!!t?new Date(t):t}_isChanged(t,r){return!(r&&!!t&&(t===r||t instanceof Date&&r instanceof Date&&t.getTime()===r.getTime())||!r&&!t&&r===t)}_applyTimezone(t,r){return r.timezone?_.tz.zone(r.timezone)?_(t).tz(r.timezone):t=S(t).utcOffset(r.timezone):_(t)}_stringify(t,r){return t=this._applyTimezone(t,r),t.format("YYYY-MM-DD HH:mm:ss.SSS Z")}}s(M,"DATE");class C extends i{toSql(){return"DATE"}_stringify(t){return S(t).format("YYYY-MM-DD")}_sanitize(t,r){return(!r||r&&!r.raw)&&!!t?S(t).format("YYYY-MM-DD"):t}_isChanged(t,r){return!(r&&!!t&&r===t||!r&&!t&&r===t)}}s(C,"DATEONLY");class $ extends i{validate(t){if(!c.isPlainObject(t))throw new n.ValidationError(o.format("%j is not a valid hstore",t));return!0}}s($,"HSTORE");class q extends i{validate(){return!0}_stringify(t){return JSON.stringify(t)}}s(q,"JSONTYPE");class V extends q{}s(V,"JSONB");class U extends i{}s(U,"NOW");class I extends i{constructor(t){super();const r=typeof t=="object"&&t||{length:t};this.options=r,this._length=r.length||""}toSql(){switch(this._length.toLowerCase()){case"tiny":return"TINYBLOB";case"medium":return"MEDIUMBLOB";case"long":return"LONGBLOB";default:return this.key}}validate(t){if(typeof t!="string"&&!Buffer.isBuffer(t))throw new n.ValidationError(o.format("%j is not a valid blob",t));return!0}_stringify(t){Buffer.isBuffer(t)||(Array.isArray(t)?t=Buffer.from(t):t=Buffer.from(t.toString()));const r=t.toString("hex");return this._hexify(r)}_hexify(t){return`X'${t}'`}_bindParam(t,r){return Buffer.isBuffer(t)||(Array.isArray(t)?t=Buffer.from(t):t=Buffer.from(t.toString())),r.bindParam(t)}}s(I,"BLOB"),I.prototype.escape=!1;class F extends i{constructor(t){super();const r=c.isPlainObject(t)?t:{subtype:t};r.subtype||(r.subtype=new l),typeof r.subtype=="function"&&(r.subtype=new r.subtype),this._subtype=r.subtype.key,this.options=r}validate(t){if(!Array.isArray(t))throw new n.ValidationError(o.format("%j is not a valid range",t));if(t.length!==2)throw new n.ValidationError("A range must be an array with two elements");return!0}}s(F,"RANGE");class R extends i{validate(t,r){if(typeof t!="string"||!f.isUUID(t)&&(!r||!r.acceptStrings))throw new n.ValidationError(o.format("%j is not a valid uuid",t));return!0}}s(R,"UUID");class J extends i{validate(t,r){if(typeof t!="string"||!f.isUUID(t)&&(!r||!r.acceptStrings))throw new n.ValidationError(o.format("%j is not a valid uuid",t));return!0}}s(J,"UUIDV1");class X extends i{validate(t,r){if(typeof t!="string"||!f.isUUID(t,4)&&(!r||!r.acceptStrings))throw new n.ValidationError(o.format("%j is not a valid uuidv4",t));return!0}}s(X,"UUIDV4");class Z extends i{constructor(t,r){super();typeof t=="function"&&(t=new t),this.returnType=t,this.fields=r}}s(Z,"VIRTUAL");class H extends i{constructor(...t){super();const r=t[0],a=typeof r=="object"&&!Array.isArray(r)&&r||{values:t.reduce((rt,w)=>rt.concat(Array.isArray(w)?w:[w]),[])};this.values=a.values,this.options=a}validate(t){if(!this.values.includes(t))throw new n.ValidationError(o.format("%j is not a valid choice in %j",t,this.values));return!0}}s(H,"ENUM");class g extends i{constructor(t){super();const r=c.isPlainObject(t)?t:{type:t};this.options=r,this.type=typeof r.type=="function"?new r.type:r.type}toSql(){return`${this.type.toSql()}[]`}validate(t){if(!Array.isArray(t))throw new n.ValidationError(o.format("%j is not a valid array",t));return!0}static is(t,r){return t instanceof g&&t.type instanceof r}}s(g,"ARRAY");class N extends i{constructor(t,r){super();const a=c.isPlainObject(t)?t:{type:t,srid:r};this.options=a,this.type=a.type,this.srid=a.srid}_stringify(t,r){return`ST_GeomFromText(${r.escape(y.Geometry.parseGeoJSON(t).toWkt())})`}_bindParam(t,r){return`ST_GeomFromText(${r.bindParam(y.Geometry.parseGeoJSON(t).toWkt())})`}}s(N,"GEOMETRY"),N.prototype.escape=!1;class O extends i{constructor(t,r){super();const a=c.isPlainObject(t)?t:{type:t,srid:r};this.options=a,this.type=a.type,this.srid=a.srid}_stringify(t,r){return`ST_GeomFromText(${r.escape(y.Geometry.parseGeoJSON(t).toWkt())})`}_bindParam(t,r){return`ST_GeomFromText(${r.bindParam(y.Geometry.parseGeoJSON(t).toWkt())})`}}s(O,"GEOGRAPHY"),O.prototype.escape=!1;class W extends i{validate(t){if(typeof t!="string"||!f.isIPRange(t))throw new n.ValidationError(o.format("%j is not a valid CIDR",t));return!0}}s(W,"CIDR");class Q extends i{validate(t){if(typeof t!="string"||!f.isIP(t))throw new n.ValidationError(o.format("%j is not a valid INET",t));return!0}}s(Q,"INET");class K extends i{validate(t){if(typeof t!="string"||!f.isMACAddress(t))throw new n.ValidationError(o.format("%j is not a valid MACADDR",t));return!0}}s(K,"MACADDR");class v extends i{validate(t){if(typeof t!="string")throw new n.ValidationError(o.format("%j is not a valid string",t));return!0}}s(v,"TSVECTOR");const d=module.exports={ABSTRACT:i,STRING:b,CHAR:A,TEXT:B,NUMBER:u,TINYINT:L,SMALLINT:z,MEDIUMINT:P,INTEGER:l,BIGINT:Y,FLOAT:x,TIME:G,DATE:M,DATEONLY:C,BOOLEAN:m,NOW:U,BLOB:I,DECIMAL:j,NUMERIC:j,UUID:R,UUIDV1:J,UUIDV4:X,HSTORE:$,JSON:q,JSONB:V,VIRTUAL:Z,ARRAY:g,ENUM:H,RANGE:F,REAL:E,"DOUBLE PRECISION":p,DOUBLE:p,GEOMETRY:N,GEOGRAPHY:O,CIDR:W,INET:Q,MACADDR:K,CITEXT:k,TSVECTOR:v};c.each(d,(e,t)=>{Object.prototype.hasOwnProperty.call(e,"key")||(e.types={},e.key=e.prototype.key=t)});const h={};h.postgres=require("./dialects/postgres/data-types")(d),h.mysql=require("./dialects/mysql/data-types")(d),h.mariadb=require("./dialects/mariadb/data-types")(d),h.sqlite=require("./dialects/sqlite/data-types")(d),h.mssql=require("./dialects/mssql/data-types")(d);const tt=Object.values(h);for(const e of tt)c.each(e,(t,r)=>{t.key||(t.key=t.prototype.key=r)});for(const e of[d,...tt])c.each(e,(t,r)=>{e[r]=it(t)});Object.assign(d,h);
//# sourceMappingURL=data-types.js.map
