"use strict";var Z=Object.defineProperty;var F=Object.getOwnPropertySymbols;var oe=Object.prototype.hasOwnProperty,le=Object.prototype.propertyIsEnumerable;var ee=(O,e,t)=>e in O?Z(O,e,{enumerable:!0,configurable:!0,writable:!0,value:t}):O[e]=t,te=(O,e)=>{for(var t in e||(e={}))oe.call(e,t)&&ee(O,t,e[t]);if(F)for(var t of F(e))le.call(e,t)&&ee(O,t,e[t]);return O};var w=(O,e)=>Z(O,"name",{value:e,configurable:!0});const N=require("lodash"),ue=require("../../sql-string"),m=require("../../query-types"),ae=require("dottie"),fe=require("../../utils/deprecations"),he=require("uuid").v4;class B{constructor(e,t,r){this.uuid=he(),this.connection=e,this.instance=r.instance,this.model=r.model,this.sequelize=t,this.options=te({plain:!1,raw:!1,logging:console.log},r),this.checkLoggingOption()}static formatBindParameters(e,t,r,i,s){if(!t)return[e,[]];if(s=s||{},typeof i!="function"&&(s=i||{},i=void 0),!i)s.skipValueReplace?i=w((p,l,c)=>{if(c[l]!==void 0)return p},"replacementFunc"):i=w((p,l,c,q,d)=>{if(c[l]!==void 0)return ue.escape(c[l],q,d)},"replacementFunc");else if(s.skipValueReplace){const p=i;i=w((l,c,q,d,S,T)=>{if(p(l,c,q,d,S,T)!==void 0)return l},"replacementFunc")}const n=null,a=Array.isArray(t);return e=e.replace(/\B\$(\$|\w+)/g,(p,l)=>{if(l==="$")return s.skipUnescape?p:l;let c;if(a?l.match(/^[1-9]\d*$/)&&(l=l-1,c=i(p,l,t,n,r,s)):l.match(/^\d*$/)||(c=i(p,l,t,n,r,s)),c===void 0)throw new Error(`Named bind parameter "${p}" has no value in the given object.`);return c}),[e,[]]}run(){throw new Error("The run method wasn't overwritten!")}checkLoggingOption(){this.options.logging===!0&&(fe.noTrueLogging(),this.options.logging=console.log)}getInsertIdField(){return"insertId"}getUniqueConstraintErrorMessage(e){let t=e?`${e} must be unique`:"Must be unique";if(e&&this.model)for(const r of Object.keys(this.model.uniqueKeys))this.model.uniqueKeys[r].fields.includes(e.replace(/"/g,""))&&this.model.uniqueKeys[r].msg&&(t=this.model.uniqueKeys[r].msg);return t}isRawQuery(){return this.options.type===m.RAW}isVersionQuery(){return this.options.type===m.VERSION}isUpsertQuery(){return this.options.type===m.UPSERT}isInsertQuery(e,t){let r=!0;return this.options.type===m.INSERT?!0:(r=r&&this.sql.toLowerCase().startsWith("insert into"),r=r&&(!e||Object.prototype.hasOwnProperty.call(e,this.getInsertIdField())),r=r&&(!t||Object.prototype.hasOwnProperty.call(t,this.getInsertIdField())),r)}handleInsertQuery(e,t){if(this.instance){const r=this.model.autoIncrementAttribute;let i=null;i=i||e&&e[this.getInsertIdField()],i=i||t&&t[this.getInsertIdField()],this.instance[r]=i}}isShowTablesQuery(){return this.options.type===m.SHOWTABLES}handleShowTablesQuery(e){return N.flatten(e.map(t=>Object.values(t)))}isShowIndexesQuery(){return this.options.type===m.SHOWINDEXES}isShowConstraintsQuery(){return this.options.type===m.SHOWCONSTRAINTS}isDescribeQuery(){return this.options.type===m.DESCRIBE}isSelectQuery(){return this.options.type===m.SELECT}isBulkUpdateQuery(){return this.options.type===m.BULKUPDATE}isBulkDeleteQuery(){return this.options.type===m.BULKDELETE}isForeignKeysQuery(){return this.options.type===m.FOREIGNKEYS}isUpdateQuery(){return this.options.type===m.UPDATE}handleSelectQuery(e){let t=null;if(this.options.fieldMap){const r=this.options.fieldMap;e=e.map(i=>N.reduce(r,(s,n,a)=>(s[a]!==void 0&&n!==a&&(s[n]=s[a],delete s[a]),s),i))}return this.options.raw?t=e.map(r=>{let i={};for(const s in r)Object.prototype.hasOwnProperty.call(r,s)&&(i[s]=r[s]);return this.options.nest&&(i=ae.transform(i)),i}):this.options.hasJoin===!0?(e=B._groupJoinData(e,{model:this.model,includeMap:this.options.includeMap,includeNames:this.options.includeNames},{checkExisting:this.options.hasMultiAssociation}),t=this.model.bulkBuild(e,{isNewRecord:!1,include:this.options.include,includeNames:this.options.includeNames,includeMap:this.options.includeMap,includeValidated:!0,attributes:this.options.originalAttributes||this.options.attributes,raw:!0})):t=this.model.bulkBuild(e,{isNewRecord:!1,raw:!0,attributes:this.options.originalAttributes||this.options.attributes}),this.options.plain&&(t=t.length===0?null:t[0]),t}isShowOrDescribeQuery(){let e=!1;return e=e||this.sql.toLowerCase().startsWith("show"),e=e||this.sql.toLowerCase().startsWith("describe"),e}isCallQuery(){return this.sql.toLowerCase().startsWith("call")}_logQuery(e,t,r){const{connection:i,options:s}=this,n=this.sequelize.options.benchmark||s.benchmark,a=this.sequelize.options.logQueryParameters||s.logQueryParameters,p=Date.now();let l="";if(a&&r){const d=e.endsWith(";")?"":";";let S;Array.isArray(r)?S=r.map(T=>JSON.stringify(T)).join(", "):S=JSON.stringify(r),l=`${d} ${S}`}const c=`(${i.uuid||"default"}): ${e}${l}`,q=`Executing ${c}`;return t(q),n||this.sequelize.log(`Executing ${c}`,s),()=>{const d=`Executed ${c}`;t(d),n&&this.sequelize.log(d,Date.now()-p,s)}}static _groupJoinData(e,t,r){if(!e.length)return[];let i,s,n,a,p,l;const c=e.length;let q,d,S,T,D,P,U,v;const C=r.checkExisting;let u,b,E;const k=C?[]:new Array(c),$={},g={};let Q,J,ie,K,x,I,f,L;const se=w(o=>{Object.prototype.hasOwnProperty.call(I.includeMap,o)&&(g[d]=I=I.includeMap[o],L?L=`${L}.${o}`:L=o,g[L]=I)},"buildIncludeMap"),_={},G=w((o,h)=>(Object.prototype.hasOwnProperty.call(h,o)||(h[o]=o.substr(0,o.lastIndexOf("."))),h[o]),"keyPrefixString"),V={},re=w(o=>{if(!Object.prototype.hasOwnProperty.call(V,o)){const h=o.lastIndexOf(".");V[o]=o.substr(h===-1?0:h+1)}return V[o]},"removeKeyPrefix"),j={},X=w(o=>{if(!Object.prototype.hasOwnProperty.call(j,o)){const h=G(o,_);Object.prototype.hasOwnProperty.call(j,h)||(j[h]=h?h.split("."):[]),j[o]=j[h]}return j[o]},"keyPrefix"),H={},Y=w(o=>{if(!Object.prototype.hasOwnProperty.call(H,o)){const h=X(o),W=h.length;H[o]=W?h[W-1]:""}return H[o]},"lastKeyPrefix"),z=w(o=>{let h=N.chain(o.uniqueKeys);return h=h.result(`${h.findKey()}.fields`).map(W=>N.findKey(o.attributes,ne=>ne.field===W)).value(),h},"getUniqueKeyAttributes"),R=w(o=>o instanceof Buffer?o.toString("hex"):o,"stringify");let M,A,y;for(p=0;p<c;p++){if(l=e[p],p===0&&(q=Object.keys(l),T=q.length),C){if(v=!1,a=t.model.primaryKeyAttributes.length,E="",a===1)E=R(l[t.model.primaryKeyAttributes[0]]);else if(a>1)for(n=0;n<a;n++)E+=R(l[t.model.primaryKeyAttributes[n]]);else if(!N.isEmpty(t.model.uniqueKeys))for(A=z(t.model),n=0;n<A.length;n++)E+=l[A[n]]}for(U=P={},K=void 0,S=0;S<T;S++){if(d=q[S],J=G(d,_),Q=X(d),p===0&&!Object.prototype.hasOwnProperty.call(g,d)&&(Q.length?(I=t,L=void 0,Q.forEach(se)):g[d]=g[""]=t),K!==void 0&&K!==Q){if(C){if(s=K.length,f=null,b=null,s)for(i=0;i<s;i++){if(y=f?`${f}.${K[i]}`:K[i],M=g[y].model.primaryKeyAttributes,a=M.length,u=y,a===1)u+=R(l[`${y}.${M[0]}`]);else if(a>1)for(n=0;n<a;n++)u+=R(l[`${y}.${M[n]}`]);else if(!N.isEmpty(g[y].model.uniqueKeys))for(A=z(g[y].model),n=0;n<A.length;n++)u+=l[`${y}.${A[n]}`];b||(b=E),u=b+u,f=y,i<s-1&&(b=u)}else u=E;u===E?$[u]?v=!0:$[u]=P:$[u]||(f=$[b],x=Y(D),g[D].association.isSingleAssociation?f&&(f[x]=$[u]=P):(f[x]||(f[x]=[]),f[x].push($[u]=P))),P={}}else if(I=U,s=Q.length,s)for(i=0;i<s;i++)i===s-1&&(P=I[Q[i]]={}),I=I[Q[i]]||{}}P[re(d)]=l[d],D=d,K=Q,ie=J}if(C){if(s=K.length,f=null,b=null,s)for(i=0;i<s;i++){if(y=f?`${f}.${K[i]}`:K[i],M=g[y].model.primaryKeyAttributes,a=M.length,u=y,a===1)u+=R(l[`${y}.${M[0]}`]);else if(a>0)for(n=0;n<a;n++)u+=R(l[`${y}.${M[n]}`]);else if(!N.isEmpty(g[y].model.uniqueKeys))for(A=z(g[y].model),n=0;n<A.length;n++)u+=l[`${y}.${A[n]}`];b||(b=E),u=b+u,f=y,i<s-1&&(b=u)}else u=E;u===E?$[u]?v=!0:$[u]=P:$[u]||(f=$[b],x=Y(D),g[D].association.isSingleAssociation?f&&(f[x]=$[u]=P):(f[x]||(f[x]=[]),f[x].push($[u]=P))),v||k.push(U)}else k[p]=U}return k}}w(B,"AbstractQuery"),module.exports=B,module.exports.AbstractQuery=B,module.exports.default=B;
//# sourceMappingURL=query.js.map
