"use strict";var m=Object.defineProperty;var p=Object.getOwnPropertySymbols;var Q=Object.prototype.hasOwnProperty,I=Object.prototype.propertyIsEnumerable;var w=(o,e,s)=>e in o?m(o,e,{enumerable:!0,configurable:!0,writable:!0,value:s}):o[e]=s,g=(o,e)=>{for(var s in e||(e={}))Q.call(e,s)&&w(o,s,e[s]);if(p)for(var s of p(e))I.call(e,s)&&w(o,s,e[s]);return o};var h=(o,e)=>m(o,"name",{value:e,configurable:!0});const E=require("../abstract/query"),c=require("../../errors"),R=require("lodash"),d=require("../../data-types"),{logger:A}=require("../../utils/logger"),q=1062,C=1213,b=1451,O=1452,_=A.debugContext("sql:mariadb");class N extends E{constructor(e,s,t){super(e,s,g({showWarnings:!1},t))}static formatBindParameters(e,s,t){const n=[],r=h((a,i,l)=>{if(l[i]!==void 0)return n.push(l[i]),"?"},"replacementFunc");return e=E.formatBindParameters(e,s,t,r)[0],[e,n.length>0?n:void 0]}async run(e,s){this.sql=e;const{connection:t,options:n}=this,r=this.sequelize.options.showWarnings||n.showWarnings,a=this._logQuery(e,_,s);s&&_("parameters(%j)",s);let i;const l=new Error;try{i=await t.query(this.sql,s)}catch(u){if(n.transaction&&u.errno===C){try{await n.transaction.rollback()}catch(f){}n.transaction.finished="rollback"}throw u.sql=e,u.parameters=s,this.formatError(u,l.stack)}finally{a()}return r&&i&&i.warningStatus>0&&await this.logWarnings(i),this.formatResults(i)}formatResults(e){let s=this.instance;if(this.isBulkUpdateQuery()||this.isBulkDeleteQuery())return e.affectedRows;if(this.isUpsertQuery())return[s,e.affectedRows===1];if(this.isInsertQuery(e)&&(this.handleInsertQuery(e),!this.instance)){if(this.model&&this.model.autoIncrementAttribute&&this.model.autoIncrementAttribute===this.model.primaryKeyAttribute&&this.model.rawAttributes[this.model.primaryKeyAttribute]){const t=e[this.getInsertIdField()];s=new Array(e.affectedRows);const n=this.model.rawAttributes[this.model.primaryKeyAttribute].field;for(let r=0;r<e.affectedRows;r++)s[r]={[n]:t+r};return[s,e.affectedRows]}return[e[this.getInsertIdField()],e.affectedRows]}if(this.isSelectQuery())return this.handleJsonSelectQuery(e),this.handleSelectQuery(e);if(this.isInsertQuery()||this.isUpdateQuery())return[s,e.affectedRows];if(this.isCallQuery())return e[0];if(this.isRawQuery()){const t=e.meta;return delete e.meta,[e,t]}if(this.isShowIndexesQuery())return this.handleShowIndexesQuery(e);if(this.isForeignKeysQuery()||this.isShowConstraintsQuery())return e;if(this.isShowTablesQuery())return this.handleShowTablesQuery(e);if(this.isDescribeQuery()){s={};for(const t of e)s[t.Field]={type:t.Type.toLowerCase().startsWith("enum")?t.Type.replace(/^enum/i,"ENUM"):t.Type.toUpperCase(),allowNull:t.Null==="YES",defaultValue:t.Default,primaryKey:t.Key==="PRI",autoIncrement:Object.prototype.hasOwnProperty.call(t,"Extra")&&t.Extra.toLowerCase()==="auto_increment",comment:t.Comment?t.Comment:null};return s}return this.isVersionQuery()?e[0].version:s}handleJsonSelectQuery(e){if(!(!this.model||!this.model.fieldRawAttributesMap))for(const s of Object.keys(this.model.fieldRawAttributesMap)){const t=this.model.fieldRawAttributesMap[s];t.type instanceof d.JSON&&(e=e.map(n=>(n[t.fieldName]&&typeof n[t.fieldName]=="string"&&(n[t.fieldName]=JSON.parse(n[t.fieldName])),d.JSON.parse?d.JSON.parse(t,this.sequelize.options,n[t.fieldName]):n)))}}async logWarnings(e){const s=await this.run("SHOW WARNINGS"),t=`MariaDB Warnings (${this.connection.uuid||"default"}): `,n=[];for(const r of s)if(!(r===void 0||typeof r[Symbol.iterator]!="function"))for(const a of r)if(Object.prototype.hasOwnProperty.call(a,"Message"))n.push(a.Message);else for(const i of a.keys())n.push([i,a[i]].join(": "));return this.sequelize.log(t+n.join("; "),this.options),e}formatError(e,s){switch(e.errno){case q:{const t=e.message.match(/Duplicate entry '([\s\S]*)' for key '?((.|\s)*?)'?\s.*$/);let n={},r="Validation error";const a=t?t[1].split("-"):void 0,i=t?t[2]:void 0,l=t?t[1]:void 0,u=this.model&&this.model.uniqueKeys[i];u?(u.msg&&(r=u.msg),n=R.zipObject(u.fields,a)):n[i]=l;const f=[];return R.forOwn(n,(S,y)=>{f.push(new c.ValidationErrorItem(this.getUniqueConstraintErrorMessage(y),"unique violation",y,S,this.instance,"not_unique"))}),new c.UniqueConstraintError({message:r,errors:f,parent:e,fields:n,stack:s})}case b:case O:{const t=e.message.match(/CONSTRAINT ([`"])(.*)\1 FOREIGN KEY \(\1(.*)\1\) REFERENCES \1(.*)\1 \(\1(.*)\1\)/),n=t?t[1]:"`",r=t?t[3].split(new RegExp(`${n}, *${n}`)):void 0;return new c.ForeignKeyConstraintError({reltype:e.errno===b?"parent":"child",table:t?t[4]:void 0,fields:r,value:r&&r.length&&this.instance&&this.instance[r[0]]||void 0,index:t?t[2]:void 0,parent:e,stack:s})}default:return new c.DatabaseError(e,{stack:s})}}handleShowTablesQuery(e){return e.map(s=>({tableName:s.TABLE_NAME,schema:s.TABLE_SCHEMA}))}handleShowIndexesQuery(e){let s;const t=[];return e.forEach(n=>{(!s||s.name!==n.Key_name)&&(s={primary:n.Key_name==="PRIMARY",fields:[],name:n.Key_name,tableName:n.Table,unique:n.Non_unique!==1,type:n.Index_type},t.push(s)),s.fields[n.Seq_in_index-1]={attribute:n.Column_name,length:n.Sub_part||void 0,order:n.Collation==="A"?"ASC":void 0}}),t}}h(N,"Query"),module.exports=N;
//# sourceMappingURL=query.js.map
