"use strict";var F=Object.defineProperty;var q=Object.getOwnPropertySymbols;var j=Object.prototype.hasOwnProperty,P=Object.prototype.propertyIsEnumerable;var B=(O,e,t)=>e in O?F(O,e,{enumerable:!0,configurable:!0,writable:!0,value:t}):O[e]=t,g=(O,e)=>{for(var t in e||(e={}))j.call(e,t)&&B(O,t,e[t]);if(q)for(var t of q(e))P.call(e,t)&&B(O,t,e[t]);return O};var M=(O,e)=>F(O,"name",{value:e,configurable:!0});const L=require("lodash"),N=require("../../utils"),K=require("../../data-types"),Q=require("../../table-hints"),Y=require("../abstract/query-generator"),W=require("crypto").randomBytes,p=require("semver"),J=require("../../operators"),y=M(function(O){throw new Error(`The method "${O}" is not defined! Please add it to your sql dialect.`)},"throwMethodUndefined");class H extends Y{createDatabaseQuery(e,t){t=g({collate:null},t);const n=t.collate?`COLLATE ${this.escape(t.collate)}`:"";return["IF NOT EXISTS (SELECT * FROM sys.databases WHERE name =",I(e),")","BEGIN","CREATE DATABASE",this.quoteIdentifier(e),`${n};`,"END;"].join(" ")}dropDatabaseQuery(e){return["IF EXISTS (SELECT * FROM sys.databases WHERE name =",I(e),")","BEGIN","DROP DATABASE",this.quoteIdentifier(e),";","END;"].join(" ")}createSchema(e){return["IF NOT EXISTS (SELECT schema_name","FROM information_schema.schemata","WHERE schema_name =",I(e),")","BEGIN","EXEC sp_executesql N'CREATE SCHEMA",this.quoteIdentifier(e),";'","END;"].join(" ")}dropSchema(e){const t=I(e);return["IF EXISTS (SELECT schema_name","FROM information_schema.schemata","WHERE schema_name =",t,")","BEGIN","DECLARE @id INT, @ms_sql NVARCHAR(2000);","DECLARE @cascade TABLE (","id INT NOT NULL IDENTITY PRIMARY KEY,","ms_sql NVARCHAR(2000) NOT NULL );","INSERT INTO @cascade ( ms_sql )","SELECT CASE WHEN o.type IN ('F','PK')","THEN N'ALTER TABLE ['+ s.name + N'].[' + p.name + N'] DROP CONSTRAINT [' + o.name + N']'","ELSE N'DROP TABLE ['+ s.name + N'].[' + o.name + N']' END","FROM sys.objects o","JOIN sys.schemas s on o.schema_id = s.schema_id","LEFT OUTER JOIN sys.objects p on o.parent_object_id = p.object_id","WHERE o.type IN ('F', 'PK', 'U') AND s.name = ",t,"ORDER BY o.type ASC;","SELECT TOP 1 @id = id, @ms_sql = ms_sql FROM @cascade ORDER BY id;","WHILE @id IS NOT NULL","BEGIN","BEGIN TRY EXEC sp_executesql @ms_sql; END TRY","BEGIN CATCH BREAK; THROW; END CATCH;","DELETE FROM @cascade WHERE id = @id;","SELECT @id = NULL, @ms_sql = NULL;","SELECT TOP 1 @id = id, @ms_sql = ms_sql FROM @cascade ORDER BY id;","END","EXEC sp_executesql N'DROP SCHEMA",this.quoteIdentifier(e),";'","END;"].join(" ")}showSchemasQuery(){return['SELECT "name" as "schema_name" FROM sys.schemas as s','WHERE "s"."name" NOT IN (',"'INFORMATION_SCHEMA', 'dbo', 'guest', 'sys', 'archive'",")","AND",'"s"."name" NOT LIKE',"'db_%'"].join(" ")}versionQuery(){return["DECLARE @ms_ver NVARCHAR(20);","SET @ms_ver = REVERSE(CONVERT(NVARCHAR(20), SERVERPROPERTY('ProductVersion')));","SELECT REVERSE(SUBSTRING(@ms_ver, CHARINDEX('.', @ms_ver)+1, 20)) AS 'version'"].join(" ")}createTableQuery(e,t,n){const i=[],r={},s=[];let c="";for(const E in t)if(Object.prototype.hasOwnProperty.call(t,E)){let o=t[E],u;if(o.includes("COMMENT ")){const S=o.match(/^(.+) (COMMENT.*)$/),h=S[2].replace("COMMENT","").trim();c+=this.commentTemplate(h,e,E),o=S[1]}o.includes("PRIMARY KEY")?(i.push(E),o.includes("REFERENCES")?(u=o.match(/^(.+) (REFERENCES.*)$/),s.push(`${this.quoteIdentifier(E)} ${u[1].replace("PRIMARY KEY","")}`),r[E]=u[2]):s.push(`${this.quoteIdentifier(E)} ${o.replace("PRIMARY KEY","")}`)):o.includes("REFERENCES")?(u=o.match(/^(.+) (REFERENCES.*)$/),s.push(`${this.quoteIdentifier(E)} ${u[1]}`),r[E]=u[2]):s.push(`${this.quoteIdentifier(E)} ${o}`)}const T=i.map(E=>this.quoteIdentifier(E)).join(", ");n.uniqueKeys&&L.each(n.uniqueKeys,(E,o)=>{E.customIndex&&(typeof o!="string"&&(o=`uniq_${e}_${E.fields.join("_")}`),s.push(`CONSTRAINT ${this.quoteIdentifier(o)} UNIQUE (${E.fields.map(u=>this.quoteIdentifier(u)).join(", ")})`))}),T.length>0&&s.push(`PRIMARY KEY (${T})`);for(const E in r)Object.prototype.hasOwnProperty.call(r,E)&&s.push(`FOREIGN KEY (${this.quoteIdentifier(E)}) ${r[E]}`);const A=this.quoteTable(e);return N.joinSQLFragments([`IF OBJECT_ID('${A}', 'U') IS NULL`,`CREATE TABLE ${A} (${s.join(", ")})`,";",c])}describeTableQuery(e,t){let n=["SELECT","c.COLUMN_NAME AS 'Name',","c.DATA_TYPE AS 'Type',","c.CHARACTER_MAXIMUM_LENGTH AS 'Length',","c.IS_NULLABLE as 'IsNull',","COLUMN_DEFAULT AS 'Default',","pk.CONSTRAINT_TYPE AS 'Constraint',","COLUMNPROPERTY(OBJECT_ID(c.TABLE_SCHEMA+'.'+c.TABLE_NAME), c.COLUMN_NAME, 'IsIdentity') as 'IsIdentity',","CAST(prop.value AS NVARCHAR) AS 'Comment'","FROM","INFORMATION_SCHEMA.TABLES t","INNER JOIN","INFORMATION_SCHEMA.COLUMNS c ON t.TABLE_NAME = c.TABLE_NAME AND t.TABLE_SCHEMA = c.TABLE_SCHEMA","LEFT JOIN (SELECT tc.table_schema, tc.table_name, ","cu.column_name, tc.CONSTRAINT_TYPE ","FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS tc ","JOIN INFORMATION_SCHEMA.KEY_COLUMN_USAGE  cu ","ON tc.table_schema=cu.table_schema and tc.table_name=cu.table_name ","and tc.constraint_name=cu.constraint_name ","and tc.CONSTRAINT_TYPE='PRIMARY KEY') pk ","ON pk.table_schema=c.table_schema ","AND pk.table_name=c.table_name ","AND pk.column_name=c.column_name ","INNER JOIN sys.columns AS sc","ON sc.object_id = object_id(t.table_schema + '.' + t.table_name) AND sc.name = c.column_name","LEFT JOIN sys.extended_properties prop ON prop.major_id = sc.object_id","AND prop.minor_id = sc.column_id","AND prop.name = 'MS_Description'","WHERE t.TABLE_NAME =",I(e)].join(" ");return t&&(n+=`AND t.TABLE_SCHEMA =${I(t)}`),n}renameTableQuery(e,t){return`EXEC sp_rename ${this.quoteTable(e)}, ${this.quoteTable(t)};`}showTablesQuery(){return"SELECT TABLE_NAME, TABLE_SCHEMA FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_TYPE = 'BASE TABLE';"}dropTableQuery(e){const t=this.quoteTable(e);return N.joinSQLFragments([`IF OBJECT_ID('${t}', 'U') IS NOT NULL`,"DROP TABLE",t,";"])}addColumnQuery(e,t,n){n.field=t;let i="";return n.comment&&L.isString(n.comment)&&(i=this.commentTemplate(n.comment,e,t),delete n.comment),N.joinSQLFragments(["ALTER TABLE",this.quoteTable(e),"ADD",this.quoteIdentifier(t),this.attributeToSQL(n,{context:"addColumn"}),";",i])}commentTemplate(e,t,n){return` EXEC sp_addextendedproperty @name = N'MS_Description', @value = ${this.escape(e)}, @level0type = N'Schema', @level0name = 'dbo', @level1type = N'Table', @level1name = ${this.quoteIdentifier(t)}, @level2type = N'Column', @level2name = ${this.quoteIdentifier(n)};`}removeColumnQuery(e,t){return N.joinSQLFragments(["ALTER TABLE",this.quoteTable(e),"DROP COLUMN",this.quoteIdentifier(t),";"])}changeColumnQuery(e,t){const n=[],i=[];let r="";for(const s in t){const c=this.quoteIdentifier(s);let T=t[s];if(T.includes("COMMENT ")){const A=T.match(/^(.+) (COMMENT.*)$/),E=A[2].replace("COMMENT","").trim();r+=this.commentTemplate(E,e,s),T=A[1]}T.includes("REFERENCES")?i.push(`FOREIGN KEY (${c}) ${T.replace(/.+?(?=REFERENCES)/,"")}`):n.push(`${c} ${T}`)}return N.joinSQLFragments(["ALTER TABLE",this.quoteTable(e),n.length&&`ALTER COLUMN ${n.join(", ")}`,i.length&&`ADD ${i.join(", ")}`,";",r])}renameColumnQuery(e,t,n){const i=Object.keys(n)[0];return N.joinSQLFragments(["EXEC sp_rename",`'${this.quoteTable(e)}.${t}',`,`'${i}',`,"'COLUMN'",";"])}bulkInsertQuery(e,t,n,i){const r=this.quoteTable(e);n=n||{},i=i||{};const s=[],c=[],T=[];let A=!1,E="";n.returning&&(E=this.generateReturnValues(i,n).outputFragment);const o=`INSERT INTO ${r}${E} DEFAULT VALUES`;if(t.forEach(d=>{const l=Object.keys(d),R=i[l[0]];if(l.length===1&&R&&R.autoIncrement&&d[l[0]]===null){T.push(o);return}L.forOwn(d,(f,C)=>{if(f!==null&&i[C]&&i[C].autoIncrement&&(A=!0),!c.includes(C)){if(f===null&&i[C]&&i[C].autoIncrement)return;c.push(C)}})}),c.length>0){t.forEach(l=>{s.push(`(${c.map(R=>this.escape(l[R])).join(",")})`)});const d=c.map(l=>this.quoteIdentifier(l)).join(",");T.push(l=>`INSERT INTO ${r} (${d})${E} VALUES ${l};`)}const u=[];let S=0;const h=Math.floor(250/(c.length+1))+1;for(;S<Math.max(s.length,1);){const d=s.slice(S,Math.min(s.length,S+h));let l=T.map(R=>typeof R=="string"?R:R(d)).join(";");A&&(l=`SET IDENTITY_INSERT ${r} ON; ${l}; SET IDENTITY_INSERT ${r} OFF;`),u.push(l),S+=h}return u.join(";")}updateQuery(e,t,n,i,r){const s=super.updateQuery(e,t,n,i,r);if(i.limit){const c=`UPDATE TOP(${this.escape(i.limit)})`;s.query=s.query.replace("UPDATE",c)}return s}upsertQuery(e,t,n,i,r){const s=this.quoteTable(`${e}_target`),c=this.quoteTable(`${e}_source`),T=[],A=[],E=[],o=this.quoteTable(e);let u=!1;for(const a in r.rawAttributes)r.rawAttributes[a].primaryKey&&T.push(r.rawAttributes[a].field||a),r.rawAttributes[a].unique&&E.push(r.rawAttributes[a].field||a),r.rawAttributes[a].autoIncrement&&A.push(r.rawAttributes[a].field||a);for(const a of r._indexes)if(a.unique&&a.fields)for(const m of a.fields){const _=typeof m=="string"?m:m.name||m.attribute;!E.includes(_)&&r.rawAttributes[_]&&E.push(_)}const S=Object.keys(n),h=Object.keys(t),d=h.map(a=>this.quoteIdentifier(a)).join(", "),l=h.map(a=>this.escape(t[a])).join(", "),R=`VALUES(${l})`;let f;A.forEach(a=>{n[a]&&n[a]!==null&&(u=!0)});const C=i[J.or].filter(a=>{let m=!0;for(const _ in a)if(typeof a[_]=="undefined"||a[_]==null){m=!1;break}return m}),D=M(a=>a.map(m=>(m=this.quoteIdentifier(m),`${s}.${m} = ${c}.${m}`)),"getJoinSnippet");if(C.length===0)throw new Error("Primary Key or Unique key should be passed to upsert query");for(const a in C){const m=Object.keys(C[a]);if(T.includes(m[0])){f=D(T).join(" AND ");break}}f||(f=D(E).join(" AND "));const b=S.filter(a=>!A.includes(a)).map(a=>{const m=this.escape(n[a]);return a=this.quoteIdentifier(a),`${s}.${a} = ${m}`}).join(", "),U=`(${d}) VALUES(${l})`;let $=`MERGE INTO ${o} WITH(HOLDLOCK) AS ${s} USING (${R}) AS ${c}(${d}) ON ${f}`;return $+=` WHEN MATCHED THEN UPDATE SET ${b} WHEN NOT MATCHED THEN INSERT ${U} OUTPUT $action, INSERTED.*;`,u&&($=`SET IDENTITY_INSERT ${o} ON; ${$} SET IDENTITY_INSERT ${o} OFF;`),$}truncateTableQuery(e){return`TRUNCATE TABLE ${this.quoteTable(e)}`}deleteQuery(e,t,n={},i){const r=this.quoteTable(e),s=this.getWhereConditions(t,null,i,n);return N.joinSQLFragments(["DELETE",n.limit&&`TOP(${this.escape(n.limit)})`,"FROM",r,s&&`WHERE ${s}`,";","SELECT @@ROWCOUNT AS AFFECTEDROWS",";"])}showIndexesQuery(e){return`EXEC sys.sp_helpindex @objname = N'${this.quoteTable(e)}';`}showConstraintsQuery(e){return`EXEC sp_helpconstraint @objname = ${this.escape(this.quoteTable(e))};`}removeIndexQuery(e,t){let n=t;return typeof n!="string"&&(n=N.underscore(`${e}_${t.join("_")}`)),`DROP INDEX ${this.quoteIdentifiers(n)} ON ${this.quoteIdentifiers(e)}`}attributeToSQL(e){L.isPlainObject(e)||(e={type:e}),e.references&&e.Model&&e.Model.tableName===e.references.model&&(this.sequelize.log("MSSQL does not support self referencial constraints, we will remove it but we recommend restructuring your query"),e.onDelete="",e.onUpdate="");let t;return e.type instanceof K.ENUM?(e.type.values&&!e.values&&(e.values=e.type.values),t=e.type.toSql(),t+=` CHECK (${this.quoteIdentifier(e.field)} IN(${e.values.map(n=>this.escape(n)).join(", ")}))`,t):(t=e.type.toString(),e.allowNull===!1?t+=" NOT NULL":!e.primaryKey&&!N.defaultValueSchemable(e.defaultValue)&&(t+=" NULL"),e.autoIncrement&&(t+=" IDENTITY(1,1)"),e.type!=="TEXT"&&e.type._binary!==!0&&N.defaultValueSchemable(e.defaultValue)&&(t+=` DEFAULT ${this.escape(e.defaultValue)}`),e.unique===!0&&(t+=" UNIQUE"),e.primaryKey&&(t+=" PRIMARY KEY"),e.references&&(t+=` REFERENCES ${this.quoteTable(e.references.model)}`,e.references.key?t+=` (${this.quoteIdentifier(e.references.key)})`:t+=` (${this.quoteIdentifier("id")})`,e.onDelete&&(t+=` ON DELETE ${e.onDelete.toUpperCase()}`),e.onUpdate&&(t+=` ON UPDATE ${e.onUpdate.toUpperCase()}`)),e.comment&&typeof e.comment=="string"&&(t+=` COMMENT ${e.comment}`),t)}attributesToSQL(e,t){const n={},i=[];let r,s;for(r in e)s=e[r],s.references&&(i.includes(s.references.model.toString())?(s.onDelete="",s.onUpdate=""):(i.push(s.references.model.toString()),s.onUpdate="")),r&&!s.field&&(s.field=r),n[s.field||r]=this.attributeToSQL(s,t);return n}createTrigger(){y("createTrigger")}dropTrigger(){y("dropTrigger")}renameTrigger(){y("renameTrigger")}createFunction(){y("createFunction")}dropFunction(){y("dropFunction")}renameFunction(){y("renameFunction")}_getForeignKeysQueryPrefix(e){return`SELECT constraint_name = OBJ.NAME, constraintName = OBJ.NAME, ${e?`constraintCatalog = '${e}', `:""}constraintSchema = SCHEMA_NAME(OBJ.SCHEMA_ID), tableName = TB.NAME, tableSchema = SCHEMA_NAME(TB.SCHEMA_ID), ${e?`tableCatalog = '${e}', `:""}columnName = COL.NAME, referencedTableSchema = SCHEMA_NAME(RTB.SCHEMA_ID), ${e?`referencedCatalog = '${e}', `:""}referencedTableName = RTB.NAME, referencedColumnName = RCOL.NAME FROM sys.foreign_key_columns FKC INNER JOIN sys.objects OBJ ON OBJ.OBJECT_ID = FKC.CONSTRAINT_OBJECT_ID INNER JOIN sys.tables TB ON TB.OBJECT_ID = FKC.PARENT_OBJECT_ID INNER JOIN sys.columns COL ON COL.COLUMN_ID = PARENT_COLUMN_ID AND COL.OBJECT_ID = TB.OBJECT_ID INNER JOIN sys.tables RTB ON RTB.OBJECT_ID = FKC.REFERENCED_OBJECT_ID INNER JOIN sys.columns RCOL ON RCOL.COLUMN_ID = REFERENCED_COLUMN_ID AND RCOL.OBJECT_ID = RTB.OBJECT_ID`}getForeignKeysQuery(e,t){const n=e.tableName||e;let i=`${this._getForeignKeysQueryPrefix(t)} WHERE TB.NAME =${I(n)}`;return e.schema&&(i+=` AND SCHEMA_NAME(TB.SCHEMA_ID) =${I(e.schema)}`),i}getForeignKeyQuery(e,t){const n=e.tableName||e;return N.joinSQLFragments([this._getForeignKeysQueryPrefix(),"WHERE",`TB.NAME =${I(n)}`,"AND",`COL.NAME =${I(t)}`,e.schema&&`AND SCHEMA_NAME(TB.SCHEMA_ID) =${I(e.schema)}`])}getPrimaryKeyConstraintQuery(e,t){const n=I(e.tableName||e);return N.joinSQLFragments(["SELECT K.TABLE_NAME AS tableName,","K.COLUMN_NAME AS columnName,","K.CONSTRAINT_NAME AS constraintName","FROM INFORMATION_SCHEMA.TABLE_CONSTRAINTS AS C","JOIN INFORMATION_SCHEMA.KEY_COLUMN_USAGE AS K","ON C.TABLE_NAME = K.TABLE_NAME","AND C.CONSTRAINT_CATALOG = K.CONSTRAINT_CATALOG","AND C.CONSTRAINT_SCHEMA = K.CONSTRAINT_SCHEMA","AND C.CONSTRAINT_NAME = K.CONSTRAINT_NAME","WHERE C.CONSTRAINT_TYPE = 'PRIMARY KEY'",`AND K.COLUMN_NAME = ${I(t)}`,`AND K.TABLE_NAME = ${n}`,";"])}dropForeignKeyQuery(e,t){return N.joinSQLFragments(["ALTER TABLE",this.quoteTable(e),"DROP",this.quoteIdentifier(t)])}getDefaultConstraintQuery(e,t){const n=this.quoteTable(e);return N.joinSQLFragments(["SELECT name FROM sys.default_constraints",`WHERE PARENT_OBJECT_ID = OBJECT_ID('${n}', 'U')`,`AND PARENT_COLUMN_ID = (SELECT column_id FROM sys.columns WHERE NAME = ('${t}')`,`AND object_id = OBJECT_ID('${n}', 'U'))`,";"])}dropConstraintQuery(e,t){return N.joinSQLFragments(["ALTER TABLE",this.quoteTable(e),"DROP CONSTRAINT",this.quoteIdentifier(t),";"])}setIsolationLevelQuery(){}generateTransactionId(){return W(10).toString("hex")}startTransactionQuery(e){return e.parent?`SAVE TRANSACTION ${this.quoteIdentifier(e.name)};`:"BEGIN TRANSACTION;"}commitTransactionQuery(e){if(!e.parent)return"COMMIT TRANSACTION;"}rollbackTransactionQuery(e){return e.parent?`ROLLBACK TRANSACTION ${this.quoteIdentifier(e.name)};`:"ROLLBACK TRANSACTION;"}selectFromTableFragment(e,t,n,i,r,s){this._throwOnEmptyAttributes(n,{modelName:t&&t.name,as:r});const c=this.sequelize.options.databaseVersion,T=p.valid(c)&&p.lt(c,"11.0.0");if(T&&e.offset){const A=e.offset||0,E=e.hasIncludeWhere||e.hasIncludeRequired||e.hasMultiAssociation;let o={mainQueryOrder:[]};e.order&&(o=this.getQueryOrders(e,t,E)),o.mainQueryOrder.length===0&&o.mainQueryOrder.push(this.quoteIdentifier(t.primaryKeyField));const u=r||"OffsetTable";if(e.include){const S=e.subQuery===void 0?e.limit&&e.hasMultiAssociation:e.subQuery,d={names:{name:r,quotedName:null,as:null,model:t},options:e,subQuery:S};let l=[];for(const R of e.include){if(R.separate)continue;const f=this.generateInclude(R,{externalAs:r,internalAs:r},d);l=l.concat(f.mainQuery)}return N.joinSQLFragments(["SELECT TOP 100 PERCENT",n.join(", "),"FROM (",["SELECT",e.limit&&`TOP ${e.limit}`,"* FROM (",["SELECT ROW_NUMBER() OVER (",["ORDER BY",o.mainQueryOrder.join(", ")],`) as row_num, ${u}.* FROM (`,["SELECT DISTINCT",`${u}.* FROM ${i} AS ${u}`,l,s&&`WHERE ${s}`],`) AS ${u}`],`) AS ${u} WHERE row_num > ${A}`],`) AS ${u}`])}return N.joinSQLFragments(["SELECT TOP 100 PERCENT",n.join(", "),"FROM (",["SELECT",e.limit&&`TOP ${e.limit}`,"* FROM (",["SELECT ROW_NUMBER() OVER (",["ORDER BY",o.mainQueryOrder.join(", ")],`) as row_num, * FROM ${i} AS ${u}`,s&&`WHERE ${s}`],`) AS ${u} WHERE row_num > ${A}`],`) AS ${u}`])}return N.joinSQLFragments(["SELECT",T&&e.limit&&`TOP ${e.limit}`,n.join(", "),`FROM ${i}`,r&&`AS ${r}`,e.tableHint&&Q[e.tableHint]&&`WITH (${Q[e.tableHint]})`])}addLimitAndOffset(e,t){if(p.valid(this.sequelize.options.databaseVersion)&&p.lt(this.sequelize.options.databaseVersion,"11.0.0"))return"";const n=e.offset||0,i=e.subQuery===void 0?e.hasIncludeWhere||e.hasIncludeRequired||e.hasMultiAssociation:e.subQuery;let r="",s={};if(e.order&&(s=this.getQueryOrders(e,t,i)),e.limit||e.offset){if(!e.order||!e.order.length||e.include&&!s.subQueryOrder.length){const c=`${this.quoteTable(e.tableAs||t.name)}.${this.quoteIdentifier(t.primaryKeyField)}`;if(!e.order||!e.order.length)r+=` ORDER BY ${c}`;else{const T=L.map(e.order,E=>E[0]);L.includes(T,t.primaryKeyField)||(r+=e.order&&!i?", ":" ORDER BY ",r+=c)}}(e.offset||e.limit)&&(r+=` OFFSET ${this.escape(n)} ROWS`),e.limit&&(r+=` FETCH NEXT ${this.escape(e.limit)} ROWS ONLY`)}return r}booleanValue(e){return e?1:0}}M(H,"MSSQLQueryGenerator");function I(O){return N.addTicks(N.removeTicks(O,"'"),"'")}M(I,"wrapSingleQuote"),module.exports=H;
//# sourceMappingURL=query-generator.js.map
