"use strict";var q=Object.defineProperty;var w=(_,i)=>q(_,"name",{value:i,configurable:!0});const A=require("../abstract/query"),R=require("../../query-types"),m=require("../../errors"),p=require("lodash"),{logger:F}=require("../../utils/logger"),O=F.debugContext("sql:pg");class C extends A{static formatBindParameters(i,o,c){const l=w(n=>typeof n=="string"?n.replace(/\0/g,"\\0"):n,"stringReplaceFunc");let u;if(Array.isArray(o))u=o.map(l),i=A.formatBindParameters(i,o,c,{skipValueReplace:!0})[0];else{u=[];let n=0;const h={},s=w((E,d,y)=>{if(h[d]!==void 0)return h[d];if(y[d]!==void 0)return n=n+1,u.push(l(y[d])),h[d]=`$${n}`,`$${n}`},"replacementFunc");i=A.formatBindParameters(i,o,c,s)[0]}return[i,u]}async run(i,o){const{connection:c}=this;p.isEmpty(this.options.searchPath)||(i=this.sequelize.getQueryInterface().queryGenerator.setSearchPath(this.options.searchPath)+i),this.sequelize.options.minifyAliases&&this.options.includeAliases&&p.toPairs(this.options.includeAliases).sort((e,t)=>t[1].length-e[1].length).forEach(([e,t])=>{const r=new RegExp(p.escapeRegExp(t),"g");i=i.replace(r,e)}),this.sql=i;const l=o&&o.length?new Promise((e,t)=>c.query(i,o,(r,a)=>r?t(r):e(a))):new Promise((e,t)=>c.query(i,(r,a)=>r?t(r):e(a))),u=this._logQuery(i,O,o);let n;const h=new Error;try{n=await l}catch(e){throw e.code==="ECONNRESET"&&(c._invalid=!0),e.sql=i,e.parameters=o,this.formatError(e,h.stack)}u();let s=Array.isArray(n)?n.reduce((e,t)=>e.concat(t.rows||[]),[]):n.rows;const E=Array.isArray(n)?n.reduce((e,t)=>Number.isFinite(t.rowCount)?e+t.rowCount:e,0):n.rowCount||0;this.sequelize.options.minifyAliases&&this.options.aliasesMapping&&(s=s.map(e=>p.toPairs(e).reduce((t,[r,a])=>{const f=this.options.aliasesMapping.get(r);return t[f||r]=a,t},{})));const d=i.startsWith("SELECT table_name FROM information_schema.tables");if(i.startsWith("SELECT relname FROM pg_class WHERE oid IN"))return s.map(e=>({name:e.relname,tableName:e.relname.split("_")[0]}));if(d)return s.map(e=>Object.values(e));if(s[0]&&s[0].sequelize_caught_exception!==void 0){if(s[0].sequelize_caught_exception!==null)throw this.formatError({sql:i,parameters:o,code:"23505",detail:s[0].sequelize_caught_exception});for(const e of s)delete e.sequelize_caught_exception}if(this.isShowIndexesQuery()){for(const e of s){const t=/ON .*? (?:USING .*?\s)?\(([^]*)\)/gi.exec(e.definition)[1].split(","),r=p.zipObject(e.column_indexes,this.sequelize.getQueryInterface().queryGenerator.fromArray(e.column_names));delete e.column_indexes,delete e.column_names;let a,f;e.fields=e.indkey.split(" ").map((g,b)=>(a=r[g],a?(f=t[b],{attribute:a,collate:f.match(/COLLATE "(.*?)"/)?/COLLATE "(.*?)"/.exec(f)[1]:void 0,order:f.includes("DESC")?"DESC":f.includes("ASC")?"ASC":void 0,length:void 0}):null)).filter(g=>g!==null),delete e.columns}return s}if(this.isForeignKeysQuery()){const e=[];for(const t of s){let r;if(t.condef!==void 0&&(r=t.condef.match(/FOREIGN KEY \((.+)\) REFERENCES (.+)\((.+)\)( ON (UPDATE|DELETE) (CASCADE|RESTRICT))?( ON (UPDATE|DELETE) (CASCADE|RESTRICT))?/))){t.id=t.constraint_name,t.table=r[2],t.from=r[1],t.to=r[3];let a;for(a=5;a<=8;a+=3)/(UPDATE|DELETE)/.test(r[a])&&(t[`on_${r[a].toLowerCase()}`]=r[a+1])}e.push(t)}return e}if(this.isSelectQuery()){let e=s;if(this.options.raw===!1&&this.sequelize.options.quoteIdentifiers===!1){const t=p.reduce(this.model.rawAttributes,(r,a,f)=>(r[f.toLowerCase()]=f,r),{});e=s.map(r=>p.mapKeys(r,(a,f)=>{const g=t[f];return typeof g=="string"&&g!==f?g:f}))}return this.handleSelectQuery(e)}if(R.DESCRIBE===this.options.type){const e={};for(const t of s)if(e[t.Field]={type:t.Type.toUpperCase(),allowNull:t.Null==="YES",defaultValue:t.Default,comment:t.Comment,special:t.special?this.sequelize.getQueryInterface().queryGenerator.fromArray(t.special):[],primaryKey:t.Constraint==="PRIMARY KEY"},e[t.Field].type==="BOOLEAN"&&(e[t.Field].defaultValue={false:!1,true:!0}[e[t.Field].defaultValue],e[t.Field].defaultValue===void 0&&(e[t.Field].defaultValue=null)),typeof e[t.Field].defaultValue=="string"&&(e[t.Field].defaultValue=e[t.Field].defaultValue.replace(/'/g,""),e[t.Field].defaultValue.includes("::"))){const r=e[t.Field].defaultValue.split("::");r[1].toLowerCase()!=="regclass)"&&(e[t.Field].defaultValue=r[0])}return e}if(this.isVersionQuery())return s[0].server_version;if(this.isShowOrDescribeQuery())return s;if(R.BULKUPDATE===this.options.type)return this.options.returning?this.handleSelectQuery(s):parseInt(E,10);if(R.BULKDELETE===this.options.type)return parseInt(E,10);if(this.isInsertQuery()||this.isUpdateQuery()||this.isUpsertQuery()){if(this.instance&&this.instance.dataValues){if(this.isInsertQuery()&&E===0)throw new m.EmptyResultError;for(const e in s[0])if(Object.prototype.hasOwnProperty.call(s[0],e)){const t=s[0][e],r=p.find(this.model.rawAttributes,a=>a.fieldName===e||a.field===e);this.instance.dataValues[r&&r.fieldName||e]=t}}return this.isUpsertQuery()?[this.instance,null]:[this.instance||s&&(this.options.plain&&s[0]||s)||void 0,E]}return this.isRawQuery()?[s,n]:s}formatError(i,o){let c,l,u,n,h,s;const E=i.code||i.sqlState,d=i.message||i.messagePrimary,y=i.detail||i.messageDetail;switch(E){case"23503":return u=d.match(/violates foreign key constraint "(.+?)"/),u=u?u[1]:void 0,l=d.match(/on table "(.+?)"/),l=l?l[1]:void 0,new m.ForeignKeyConstraintError({message:d,fields:null,index:u,table:l,parent:i,stack:o});case"23505":return y&&(c=y.replace(/"/g,"").match(/Key \((.*?)\)=\((.*?)\)/))?(n=p.zipObject(c[1].split(", "),c[2].split(", ")),h=[],s="Validation error",p.forOwn(n,(e,t)=>{h.push(new m.ValidationErrorItem(this.getUniqueConstraintErrorMessage(t),"unique violation",t,e,this.instance,"not_unique"))}),this.model&&this.model.uniqueKeys&&p.forOwn(this.model.uniqueKeys,e=>{if(p.isEqual(e.fields,Object.keys(n))&&!!e.msg)return s=e.msg,!1}),new m.UniqueConstraintError({message:s,errors:h,parent:i,fields:n,stack:o})):new m.UniqueConstraintError({message:d,parent:i,stack:o});case"23P01":return c=y.match(/Key \((.*?)\)=\((.*?)\)/),c&&(n=p.zipObject(c[1].split(", "),c[2].split(", "))),s="Exclusion constraint error",new m.ExclusionConstraintError({message:s,constraint:i.constraint,fields:n,table:i.table,parent:i,stack:o});case"42704":if(i.sql&&/(CONSTRAINT|INDEX)/gi.test(i.sql))throw s="Unknown constraint error",u=d.match(/(?:constraint|index) "(.+?)"/i),u=u?u[1]:void 0,l=d.match(/relation "(.+?)"/i),l=l?l[1]:void 0,new m.UnknownConstraintError({message:s,constraint:u,fields:n,table:l,parent:i,stack:o});default:return new m.DatabaseError(i,{stack:o})}}isForeignKeysQuery(){return/SELECT conname as constraint_name, pg_catalog\.pg_get_constraintdef\(r\.oid, true\) as condef FROM pg_catalog\.pg_constraint r WHERE r\.conrelid = \(SELECT oid FROM pg_class WHERE relname = '.*' LIMIT 1\) AND r\.contype = 'f' ORDER BY 1;/.test(this.sql)}getInsertIdField(){return"id"}}w(C,"Query"),module.exports=C,module.exports.Query=C,module.exports.default=C;
//# sourceMappingURL=query.js.map
